import re, string, os

    
class DTDFile:
    def aaa(self,hit):
        try:
            return globalEntities[hit.group(1)]
        except KeyError:
            return hit.group(0)

    def __init__(self,file):
        self.unresolvedEntities={}

        self.name = file

        input = open(file)
        data = input.read()
        input.close()

        self.files = re.compile("<!ENTITY.*?\s+SYSTEM\s+[\"'](.*?)[\"']>",re.S).findall(data)
        self.files = self.files + re.compile("<!ENTITY.*?\s+PUBLIC\s+[\"'].*?[\"']\s+[\"'](.*?)[\"']\s*>",re.S).findall(data)
        self.rawEntities = re.compile("<!ENTITY\s+%\s+(\S+)\s+[\"'](.*?)[\"']\s*>",re.S).findall(data)

        for f in self.files:
            if re.compile('http://').match(f):
                continue
            if not(dtdFiles.has_key(f)):
                dtdFiles[f]=DTDFile(f)

        self.createEntityMaps()
        

    def createEntityMaps(self):
        global globalEntities
        for e in self.rawEntities:
            if re.compile('%\S+;').search(e[1]):
                self.unresolvedEntities[e[0]]=e[1]
            else:
                globalEntities[e[0]]=e[1]

        self.resolveEntityMaps()
        
    def resolveEntityMaps(self):
        global globalEntities
        for k in self.unresolvedEntities.keys():
            text = re.compile("%(\S+);").sub(self.aaa,self.unresolvedEntities[k])
            if re.compile('%\S+;').search(text):
                self.unresolvedEntities[k]=text
            else:
                globalEntities[k]=text
                del self.unresolvedEntities[k]


    def printDTDFile(self):
        print "\n\n"
        print self.name
        print "+++++++++++++++++++++"
        print "UNRESOLVED"
        print self.unresolvedEntities
            

def run(file):
    global dtdFiles, globalEntities
    
    os.chdir("../dtd")
    rootFile=file

    maxParseLevel = 10

    dtdFiles = {}
    globalEntities={}
    dtdFiles[rootFile]=DTDFile(rootFile)

    for d in dtdFiles.keys():
        if not(dtdFiles[d].rawEntities):
            del(dtdFiles[d])


    for i in range(0,maxParseLevel):
        for d in dtdFiles.values():
            d.resolveEntityMaps()

    
def expandAllEntities(file):
    os.chdir('dtd')
    run(file)
    os.chdir('..')
    return globalEntities


