<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1"
                xmlns:xhtml="http://www.w3.org/1999/xhtml"
                xmlns="http://www.w3.org/1999/xhtml">

<xsl:output method="xhtml:xhtml"/>
 
 

<xsl:template match="example">
  <xsl:choose>
    <xsl:when test="@available">
      <xsl:call-template name="exampleNotAvailable"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:call-template name="exampleAvailable"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>



<xsl:template name="exampleNotAvailable"/>



<xsl:template name="exampleAvailable">

  <xsl:if test="(source/@type='basic') or (source/@type='namespace') or (source/*)">
    <div style="display: none;">
      <xsl:choose>
        <xsl:when test="source/@type = 'basic'">
          <div id="doc">
            <div>
              Text in the first DIV.
            </div>
            <div id="DDD" class="secondClass">
              Some text in the second DIV.
            </div>
            <div class="thirdClass">
              Some text and <span id="SSS">element</span> in the third DIV.
            </div>
            <div class="fourthClass">
              We can try <i>another elements</i>.
              It will be much more <b>interesting</b>.
            </div>
            <div>
              Text in the last DIV.
            </div>
          </div>
        </xsl:when>
        <xsl:when test="source/@type = 'namespace'">
          <div id="doc" xmlns:svg="http://www.w3.org/2000/svg">
            <div>
              Text in the first DIV.
            </div>
            <svg:svg id="logo" xmlns:xlink="http://www.w3.org/1999/xlink" width="200" height="60">
              <svg:g style="fill:#3399cc; font-size:36pt; font-family:'dialog'; font-weight: bold">
                <svg:a xlink:type="simple" xlink:href="http://www.zvon.org">
                  <svg:text x="50%" y="65%" text-anchor="middle">ZVON.org</svg:text>
                </svg:a>
              </svg:g>
            </svg:svg>
            <apply xmlns="http://www.w3.org/1998/Math/MathML"> 
	      <int/> 
	      <bvar> 
	        <ci> x </ci> 
	      </bvar> 
	      <interval> 
	        <ci> a </ci> 
	        <ci> b </ci> 
	      </interval> 
	      <apply>
	        <cos/> 
	        <ci> x </ci> 
	      </apply> 
            </apply> 
            <div>
              Text in the last DIV.
            </div>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy-of select="source/*"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </xsl:if>
 
  <xsl:if test="(source/@type='basic') or (source/@type='namespace') or (source/*)">
    <table cellpadding="10" border="0">
    <tr>
      <th align="left" valign="top">Source:</th>
      <td class="source">
 <pre>
   <xsl:choose>
     <xsl:when test="source/@type = 'basic'">
   &lt;div id="doc"&gt;
     &lt;div&gt;
       Text in the first DIV.
     &lt;/div&gt;
     &lt;div id="DDD" class="secondClass"&gt;
       Some text in the second DIV.
     &lt;/div&gt;
     &lt;div class="thirdClass"&gt;
       Some text and &lt;span id="SSS"&gt;element&lt;/span&gt; in the third DIV.
     &lt;/div&gt;
     &lt;div class="fourthClass"&gt;
       We can try &lt;i&gt;another elements&lt;/i&gt;.
       It will be much more &lt;b&gt;interesting&lt;/b&gt;.
     &lt;/div&gt;
     &lt;div&gt;
       Text in the last DIV.
     &lt;/div&gt;
   &lt;/div&gt;
     </xsl:when>
     <xsl:when test="source/@type = 'namespace'">
   &lt;div id="doc" xmlns:svg="http://www.w3.org/2000/svg"&gt;
     &lt;div&gt;
       Text in the first DIV.
     &lt;/div&gt;
     &lt;svg:svg id="logo" xmlns:xlink="http://www.w3.org/1999/xlink" width="200" height="60"&gt;
       &lt;svg:g style="fill:#3399cc; font-size:36pt; font-family:'dialog'; font-weight: bold"&gt;
         &lt;svg:a xlink:type="simple" xlink:href="http://www.zvon.org"&gt;
           &lt;svg:text x="50%" y="65%" text-anchor="middle"&gt;ZVON.org&lt;/svg:text&gt;
         &lt;/svg:a&gt;
       &lt;/svg:g&gt;
     &lt;/svg:svg&gt;
     &lt;apply xmlns="http://www.w3.org/1998/Math/MathML"&gt;
   &lt;int/&gt; 
   &lt;bvar&gt; 
     &lt;ci&gt; x &lt;/ci&gt; 
   &lt;/bvar&gt; 
   &lt;interval&gt; 
     &lt;ci&gt; a &lt;/ci&gt; 
     &lt;ci&gt; b &lt;/ci&gt; 
   &lt;/interval&gt; 
   &lt;apply&gt;
     &lt;cos/&gt; 
     &lt;ci&gt; x &lt;/ci&gt; 
   &lt;/apply&gt; 
     &lt;/apply&gt; 
     &lt;div&gt;
       Text in the last DIV.
     &lt;/div&gt;
   &lt;/div&gt;
     </xsl:when>
     <xsl:otherwise>
       <xsl:call-template name="writeSource"/>
     </xsl:otherwise>
   </xsl:choose>
 </pre>
      </td>
    </tr>
    </table>
  </xsl:if>
    
    <table cellpadding="10" border="0">
    <tr>
      <th align="left" valign="top">JavaScript:</th>
      <td class="JavaScript">
        <pre>
          <xsl:value-of select="javascript"/>
        </pre>
      </td>
    </tr>
    </table>
    
    <table width="80%" cellpadding="10" border="0">
    <tr>
      <th align="left" valign="top">Output:</th>
      <td class="output">
        <table width="100%" border="1" cellspacing="0" cellpadding="5">
          <xsl:choose>
            <xsl:when test="output/desired/preserved and output/desired/nonpreserved">	<!-- white-spaces by default PRESERVED -->
              <tr align="center">
                <th width="50%" colspan="2">desired</th>
                <th width="50%">your browser</th>
              </tr>
              <tr>
                <th>white-spaces<br /><u>preserved</u><br />by&#160;default</th>
                <td align="center"><xsl:copy-of select="output/desired/preserved/node()"/></td>
                <td rowspan="2" align="center">
                  <script type="text/javascript">
                    try {
                      <xsl:value-of select="javascript"/>
                      <xsl:value-of select="output/browser"/>
                    }
                    catch (ex) {
                      document.write('&lt;span style="font-size: small;"&gt;' + ex + '&lt;/span&gt;');
                    }
                  </script>
                </td>
              </tr>
              <tr>
                <th>white-spaces<br /><u>not-preserved</u><br />by&#160;default</th>
                <td align="center"><xsl:copy-of select="output/desired/nonpreserved/node()"/></td>
              </tr>
            </xsl:when>
            <xsl:otherwise>								<!-- white-spaces by default NOT PRESERVED -->
              <tr align="center">
                <th width="50%">desired</th>
                <th width="50%">your browser</th>
              </tr>
              <tr>
                <td align="center"><xsl:copy-of select="output/desired/node()"/></td>
                <td align="center">
                  <script type="text/javascript">
                    try {
                      <xsl:value-of select="javascript"/>
                      <xsl:value-of select="output/browser"/>
                    }
                    catch (ex) {
                      document.write('&lt;span style="font-size: small;"&gt;' + ex + '&lt;/span&gt;');
                    }
                  </script>
                </td>
              </tr>
            </xsl:otherwise>
          </xsl:choose>
        </table>
      </td>
    </tr>
    </table>

</xsl:template>



<xsl:template name="writeSource">
  <xsl:apply-templates select="source/node()" mode="print"/>
</xsl:template>

<xsl:template match="*" mode="print">
  <xsl:text>&lt;</xsl:text>
  <xsl:value-of select="name()"/>
  <xsl:apply-templates select="@*" mode="print"/>
  <xsl:text>&gt;</xsl:text>
  <xsl:apply-templates mode="print"/>
  <xsl:text>&lt;/</xsl:text>
  <xsl:value-of select="name()"/>
  <xsl:text>&gt;</xsl:text>
</xsl:template>

<xsl:template match="@*" mode="print">
  <xsl:text> </xsl:text>
  <xsl:value-of select="name()"/>
  <xsl:text>="</xsl:text>
  <xsl:value-of select="."/>
  <xsl:text>"</xsl:text>
</xsl:template>



</xsl:stylesheet>
